using VOID.Generic.Dict;
using VOID.Generic.Objects.Item;
using VOID.Generic.Objects.Unit;
using VOID.Generic.Objects.Unit.Actions;
using VOID.Generic.Objects.Wearable;
using VOID.Generic.Player.Util;

namespace VOID.Generic.Player.DraggingOperation
{
    public class SceneToEquipmentDraggingOperation : AbstractDraggingOperation
    {
        public override bool Check(SelectUtilResult sourceSelect, SelectUtilResult targetSelect)
        {
            return sourceSelect.slotUI?.slotType == null
                   && targetSelect.slotUI?.slotType == SlotType.EquipmentSlot;
        }

        public override void Perform(UnitObject unit, SelectUtilResult sourceSelect, SelectUtilResult targetSelect)
        {
            if (sourceSelect.selectObject is not ItemObject item) return;
            unit.OrderStop();
            unit.Order(new MoveAction(unit, sourceSelect.position, unit.unitData.takeRange));
            var takeAction = new TakeAction(unit, item);
            unit.Order(takeAction);
            if (sourceSelect.selectObject is not WearableObject wearable) return;
            var equipAction = new EquipAction(unit, wearable);
            equipAction.runAfterAction = takeAction;
            unit.Order(equipAction);
        }
    }
}